
#define CON_SCREEN      0xB8000           /* Adresse de l'cran texte couleur */
#define NB_LIGNES       25                /* Nombre de lignes */
#define NB_COLONNES     80                /* Nombre de colonnes */

/* Attributs des caractres */
#define CON_BLACK       0
#define CON_BLUE        1
#define CON_GREEN       2
#define CON_CYAN        3
#define CON_RED         4
#define CON_MAGENTA     5
#define CON_YELLOW      6
#define CON_WHITE       7

static int attr = CON_WHITE;              /* Attribut actuel */
static unsigned int px = 0, py = 0;       /* Coordonn,es du prochain caractre */
static char *screen = (char *)CON_SCREEN; /* Pointeur vers l'cran texte */
static char *pos = (char *)CON_SCREEN;    /* Position du prochain caractre */


void scrollup(void);
void con_goto(int x, int y);
void con_putc(char c);

/* Test... */
int start(void)
{
 
 con_putc('A');
 con_putc('B');
 con_goto(12,12);
 con_putc('Z');

 while(1) {}

 return 0;
}




/* Dplace l,cran d'une ligne vers le haut et place le curseur  la
dernire ligne premire colonne */
void scrollup(void)
{
 for(pos=screen+NB_COLONNES*2; pos<=screen+(NB_LIGNES*NB_COLONNES-1)*2;
pos++)
  *(pos-NB_COLONNES*2) = *pos;

for(pos=screen+NB_COLONNES*(NB_LIGNES-1)*2-1;pos<=screen+NB_COLONNES*NB_LIGNES*2-1;pos++)
 {
  *pos++ = ' ';
  *pos   = attr;
 }
 pos = screen + NB_COLONNES*(NB_LIGNES-1)*2 - 1;   /* Curseur au d,but
de la derniSre ligne */
 px = 0;
 py = NB_LIGNES - 1;
}



/* Ecrit le caractre c en px,py */
void con_putc(char c)
{
 if (c == '\n')         /* Retour  la ligne */
 {
   if (py == NB_LIGNES)  /* Si on est  la dernire ligne */
     scrollup();
   else                  /* Sinon */
   {
     pos = pos + (NB_COLONNES - px)*2;
     py++;
   }
   px  = 0;      /* On est en dbut de ligne dans les 2 cas */
 }
 else
 {
   if (pos == screen + NB_LIGNES*NB_COLONNES*2 - 1)      /* Si on est 
la dernire ligne dernire colonne de l'cran */
     scrollup();
   *pos++ = c;
   *pos++ = attr;
   if (px == NB_COLONNES - 1)    /* Si on est en fin de ligne */
   {
     px = 0;
     py++;
   }
   else px++;                    /* Sinon on reste sur la meme ligne */
  }
}

/* Amne le curseur en x,y */
void con_goto(int x, int y)
{
 pos = screen + (y*NB_LIGNES+x)*2;    /* Chaque caractre prend 2 octets
en mmoire: code ASCII+attribut */
 px  = x;
 py  = y;
}
